﻿'code is Copyright (c) 2008 Julian M Bucknall, www.boyet.com
Public Class Form1
    private tree As BinarySearchTree(Of Char, Char)
    private bmp As Bitmap
    private keyOrder as Char() = {"p", "g", "c", "w", "s", "a", "q", "k", "e", "y", "i", "x", "m", "z", "u"}
    Private keyPointer As Integer = 0

    Public Sub PaintPanel(ByVal g As Graphics)
        Dim unit As Single = 30.0
        g.ScaleTransform(unit, unit)
        GridLines.Draw(g, pnlCanvas.Width, pnlCanvas.Height, unit)

        g.TranslateTransform(1, 1)
        Using nodePainter As New BsTreeNodePainter(Of Char, Char) (g, unit)
            Dim painter = New TreePainter(nodePainter)
            painter.DrawTree(tree.Root)
        End Using
    End Sub

    Private Sub pnlCanvas_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlCanvas.Paint
        bmp = New Bitmap(pnlCanvas.Width, pnlCanvas.Height)
        Using g As Graphics = Graphics.FromImage(bmp)
            g.Clear(Color.White)
            PaintPanel(g)
        End Using
        e.Graphics.DrawImage(bmp, 0, 0)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        tree = New BinarySearchTree(Of Char, Char)()
    End Sub

    Private Sub btnAddNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddNode.Click
        If keyPointer < keyOrder.Length Then
            tree.Insert(keyOrder(keyPointer), keyOrder(keyPointer))
            keyPointer += 1
            pnlCanvas.Invalidate()
        Else
            btnAddNode.Enabled = False
        End If
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Using saveDialog = New SaveFileDialog()
            saveDialog.DefaultExt = ".jpg"
            saveDialog.OverwritePrompt = True
            saveDialog.Title = "Save tree image"
            saveDialog.Filter = "JPG files (*.jpg)|*.jpg|All files (*.*)|*.*"
            If (saveDialog.ShowDialog() = DialogResult.OK) Then
                bmp.Save(saveDialog.FileName, System.Drawing.Imaging.ImageFormat.Jpeg)
            End If
        End Using
    End Sub

    Private Sub btnRandom_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRandom.Click
        Dim rg = New Random()

        For i As Integer = keyOrder.Length - 1 To 1 Step -1
            Dim randomIndex As Integer = rg.Next(i + 1)
            If randomIndex <> i Then
                Dim temp As Char = keyOrder(i)
                keyOrder(i) = keyOrder(randomIndex)
                keyOrder(randomIndex) = temp
            End If
        Next

        keyPointer = 0
        pnlCanvas.Invalidate()
        btnAddNode.Enabled = True
        tree = New BinarySearchTree(Of Char, Char)()
    End Sub
End Class
