' code is Copyright (c) 2008 Julian M Bucknall, www.boyet.com
Public Class TreePainter
    Private _lastNodeNumber As Integer
    Private _nodePainter As IBinaryNodePainter

    Public Sub New(ByVal nodePainter As IBinaryNodePainter)
        _nodePainter = nodePainter
        Reset()
    End Sub

    Public Sub Reset()
        _lastNodeNumber = -1
    End Sub

    Public Sub DrawLeftSubtree(ByVal node As IBinaryNode, ByVal level As Integer)
        If node IsNot Nothing Then
            Dim thisNodeNumber As Integer = DrawChildren(node, level + 1)
            _nodePainter.DrawEdgedNode(node, thisNodeNumber, level, _lastNodeNumber + 1)
        End If
    End Sub

    Public Sub DrawRightSubtree(ByVal node As IBinaryNode, ByVal level As Integer)
        If node IsNot Nothing Then
            Dim parentNodeNumber As Integer = _lastNodeNumber
            Dim thisNodeNumber As Integer = DrawChildren(node, level + 1)
            _nodePainter.DrawEdgedNode(node, thisNodeNumber, level, parentNodeNumber)
        End If
    End Sub

    Public Function DrawChildren(ByVal parent As IBinaryNode, ByVal childLevel As Integer) As Integer
        DrawLeftSubtree(parent.Left, childLevel)
        _lastNodeNumber += 1
        Dim parentNodeNumber As Integer = _lastNodeNumber
        DrawRightSubtree(parent.Right, childLevel)
        Return parentNodeNumber
    End Function

    Public Sub DrawRoot(ByRef root As IBinaryNode)
        If root IsNot Nothing Then
            Dim thisNodeNumber As Integer = DrawChildren(root, 1)
            _nodePainter.DrawNode(root, thisNodeNumber, 0)
        End If
    End Sub

    Public Sub DrawTree(ByVal root As IBinaryNode)
        Reset()
        DrawRoot(root)
    End Sub
End Class