﻿' code is Copyright (c) 2008 Julian M Bucknall, www.boyet.com
Imports RedBlackTreesVB

Public Class Tester
    Dim previousKey As Integer

    Public Function VerifyOrder(ByVal node As BSTreeNode(Of Integer, Integer)) As Boolean
        If node Is Nothing Then Return True
        If Not VerifyOrder(DirectCast(node.Left, BSTreeNode(Of Integer, Integer))) Then Return False
        If node.Key.CompareTo(previousKey) <= 0 Then Return False
        Return VerifyOrder(DirectCast(node.Right, BSTreeNode(Of Integer, Integer)))
    End Function


    Public Sub Run()
        Console.WriteLine("Testing binary search tree implementation")

        Console.WriteLine("Creating BSTree")
        Dim tree = New BinarySearchTree(Of Integer, Integer)()

        Console.WriteLine("Adding 2000 random values, and verifying tree structure...")
        Dim rg = New Random()
        Dim key As Integer
        For i As Integer = 1 To 2000
            Do
                key = rg.Next(300000)
            Loop While tree.Contains(key)

            tree.Insert(key, key + 1)
            If Not tree.Contains(key) Then
                Console.WriteLine("FAIL: new key not found")
                Console.ReadLine()
            End If

            Dim value As Integer = tree(key)
            If value <> key + 1 Then
                Console.WriteLine("FAIL: cannot retrieve value for key")
                Console.ReadLine()
            End If
            tree(key) = value + 1
            value = tree(key)
            If value <> key + 2 Then
                Console.WriteLine("FAIL: cannot retrieve new value for key")
                Console.ReadLine()
            End If
            tree(key + 300000) = value + 1
            value = tree(key + 300000)
            If value <> key + 3 Then
                Console.WriteLine("FAIL: cannot retrieve new value for extra key")
                Console.ReadLine()
            End If
            previousKey = -1
            If Not VerifyOrder(tree.Root) Then
                Console.WriteLine("FAIL: keys out of order")
                Console.ReadLine()
            End If
      Next
        Console.WriteLine("...done.")
    End Sub
End Class
Module Module1

    Sub Main()
        Dim myTester = New Tester()
        myTester.Run()

        Console.ReadLine()
    End Sub

End Module
