﻿' code is Copyright (c) 2008 Julian M Bucknall, www.boyet.com
Imports RedBlackTreesVB
Imports System.IO

Public Class Tester
    Private _shortest As Integer
    Private _longest As Integer
    Private _sumOfLengths As Integer
    Private _currentLength As Integer
    Private _externalNodeCount As Integer

    Public Sub CalculateStats(ByVal node As IBinaryNode)
        _currentLength += 1
        If node Is Nothing Then
            _externalNodeCount += 1
            If _currentLength < _shortest Then
                _shortest = _currentLength
            End If
            If _currentLength > _longest Then
                _longest = _currentLength
            End If
            _sumOfLengths += _currentLength
        Else
            CalculateStats(node.Left)
            CalculateStats(node.Right)
        End If
        _currentLength -= 1
    End Sub

    Public Sub Run()
        Console.WriteLine("Testing binary search tree balancing")
        Dim rg = New Random()

        Using sw = New StreamWriter("BalanceResults.csv")
            For loopCounter As Integer = 1 To 100
                Console.WriteLine("Creating BSTree...")
                Dim tree = New BinarySearchTree(Of Integer, Integer)()
                Console.WriteLine("Adding 2047 values...")
                Dim key As Integer
                For i As Integer = 1 To 2047
                    Do
                        key = rg.Next(300000)
                    Loop While tree.Contains(key)
                    tree.Insert(key, key + 1)
                Next

                Console.WriteLine("Calculating stats...")
                _shortest = Integer.MaxValue
                _longest = -1
                _sumOfLengths = 0
                _externalNodeCount = 0
                _currentLength = -1 ' so that the root has path length 0
                CalculateStats(tree.Root)

                sw.WriteLine(String.Format("{0},{1},{2}", _shortest, _longest, CType(_sumOfLengths, Single) / _externalNodeCount))
            Next

        End Using
        Console.WriteLine("...done")
    End Sub

End Class


Module Module1

    Sub Main()
        Dim tester = New Tester()
        tester.Run()

        Console.ReadLine()
    End Sub

End Module
